Subject: RE: Active Route

From: "Gray, Eric" <[email-masked]>
Date: Thu, 3 Oct 2002 09:59:39 -0400

Curtis,

	Nice, useful advice.

===============================================================

Manav,

	If you follow this advice, make sure you tell your
management that you threw out a possibly useful router
based on advice from the mailing list.  The problem with
doing what you suggest is that you cannot use default
routes to route traffic transiting an AS.  Because almost
nobody ever implemented behavior defined for interactions 
between BGP and any IGP, and the RFCs where these behaviors 
were defined have been re-classified as HISTORIC, it is not 
even possible to use an IGP to route traffic transiting an 
AS.

	Hence, the only way to route transit traffic in an
AS is using (i)BGP.  But keep the router; you can use it
for internal routing, in an non-transit AS or as a nifty
paper-weight or boat anchor.  :-)

Eric W. Gray
Systems Architect
Celox Networks, Inc.
[email-masked]
508 305 7214

> -----Original Message-----
> From: Curtis Villamizar [mailto:[email-masked]]
> Sent: Thursday, October 03, 2002 9:34 AM
> To: Manav Bhatia
> Cc: [email-masked]; Abarbanel, Benjamin; BGP mailing list
> Subject: Re: Active Route
> 
> 
> In message <[email-masked]>, Manav Bhatia
> writes
> :
> > Curtis,
> > | >
> > | > What if your AS is not fully meshed as Hans pointed out?
> > | >
> > | > The only way to get external BGP routes to non-BGP (IGP only)
> routers
> > is by
> > | > redistributing them via IGP, and let IGP flood them, right?
> > |
> >
> > [clipped]
> >
> > | The stance as far as the protocol spec goes is that BGP/IGP
> > | interactions are out of scope.  Special cases to support a broken AS
> > | (one with incomplete IBGP connectivity) is definitely out of scope.
> > |
> >
> > What if i have one non BGP speaking router lying in between the 2 BGP
> > speaking routers carrying transit traffic. I dont think its a broken AS
> if
> > i have this kind of topology. Things will work in this case by adding a
> > default route here on this transit non BGP speaking router. But it can
> turn
> > really messy if the number of such transit non BGP routers increase.
> 
> 
> Put in a requisition to replace that router and go find a dumpster.
> 
> 
> > | I did mention it with the intent to show that it borders on ridiculous
> > | to try to accommodate all ways in which you can build a semi-broken
> > | BGP network or build one with semi-broken equipment and get it to
> > | actually work.  We seem to agree that we don't want to go down that
> > | road, either enumerating all of the cases or with the general caveat.
> >
> > same comments as above.
> >
> > Manav
> 
> 
> Curtis

---

From: Curtis Villamizar <[email-masked]>
Date: Thu, 03 Oct 2002 10:45:28 -0400

In message <[email-masked]
> 	Nice, useful advice.

Thanks.  :-)

You could also do the "BGP free core" thingie using MPLS/TE in the
core and LSPs that go among edge routers with full BGP information.
That assumes that the reouter in the middle is MPLS/TE capable.  :-)

[Aside: Sorry for the terse response.  I thought we sufficiently beat
up the last clueless router vendor attempting to put a router in
Internet cores in about 1995 when we finally got Wellfleet to do BGP
(unfortunately they finished BGP3 in 1994 just after BGP4 was deployed
worldwide).  As Bay they finally got a BGP4 in 1995 (with horribly
inefficient BGP policy code that made it near unusable but at least
they had finally done BGP4).]

In case its not glaringly obvious.  For a router to play in the core
of a ISP network it MUST be capable of doing BGP4.  You can build toy
networks (or real enterprise networks) with non-BGP routers.  You can
also build a BGP free core using MPLS/TE, but all MPLS/TE routers I'm
aware of are also BGP4 capable.

It is very hard for an ISP to use a non-BGP4 capable router in any
capacity.  As I mentioned earlier, you can use it near or at the edge
by front ending it with a BGP capable router and get away with default
(ie: multiple defaults if you need a secondary route).

If we're going to reflect reality, we might as well reflect the
practical reality that non-BGP rotuers have no proper place in
networks that run BGP.  Given a few hacks they can be accommodated in
limited roles.  For networks with very few BGP routes (toy or
enterprise, not saying that these are the same) you have a few more
options because you can get away with putting BGP into the IGP.  These
are hacks to accommodate deficient routers.  I don't feel they have a
place in the spec.

Curtis

You could always try to unload it on EBay.  :-)

Curtis